import { ReduxClass } from './ReduxClass.class';
import { ARRAY_KEY } from './ReduxClass.constants';
import { IReduxClassArray } from './ReduxClass.interface';
export declare class ReduxClassArray extends ReduxClass implements IReduxClassArray {
    protected [ARRAY_KEY]: any[];
    static isReduxClassArray(object: object): boolean;
    static initialData(initialState: any[] | ReduxClassArray, attributes?: object): {
        array: any[];
        state: {};
    };
    constructor(initialState?: any[] | ReduxClassArray, attributes?: object);
    initialize(initialState: any[] | ReduxClassArray): void;
    initArray(_array: any[]): void;
    get(key: string | number): any;
    getArrayElement(key: number): any;
    getArray(): any[];
    getFullArray(): any[];
    getLength(): number;
    set(key: string | number, value: any): ReduxClassArray;
    setArray(_array: any[]): ReduxClassArray;
    setArrayElement(key: number, value: any): ReduxClassArray;
    isEmpty(): boolean;
    toJSON(): any[];
}
