import { AnyAction, Reducer } from 'redux';
import { ReduxClass } from './ReduxClass.class';
export declare type TAction = AnyAction;
declare type MixedState<T> = T extends ReduxClass ? ReduxClass : any;
declare function searchObjectForNew(state: ReduxClass, parentKey?: string, statePaths?: string[]): string[];
declare function traverseStateForNew(state: ReduxClass, paths?: string[]): string[];
export declare function ReduxClassWrapper<T>(reducer: Reducer<MixedState<T>>): Reducer<MixedState<T>>;
export declare const privateMethods: {
    searchObjectForNew: typeof searchObjectForNew;
    traverseStateForNew: typeof traverseStateForNew;
};
export {};
